#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK1x1x64NT1x1x4_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=1, NB=1, KB=64, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const float *stM = A + 1;
   const float *stN = B + 1;
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 1 - (((lda) << 6)), incAn = -1;
   const int incBk = (ldb), incBm = -(((ldb) << 6));
   #define incBn 1
   #define incCm 1
   const int incCn = (ldc) - 1;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float rC0_0;
   rA0 = BetaAlpha;
   rC0_0 = *pC0;
   rC0_0 *= rA0;
   for (k=64; k; k -= 4) /* easy loop to unroll */
   {
      rA0 = *pA0;
      rB0 = *pB0;
      rC0_0 += rA0 * rB0;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rC0_0 += rA0 * rB0;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rC0_0 += rA0 * rB0;
      pA0 += incAk;
      pB0 += incBk;
      rA0 = *pA0;
      rB0 = *pB0;
      rC0_0 += rA0 * rB0;
      pA0 += incAk;
      pB0 += incBk;
   }
   pA0 -= 0*incAk;
   pB0 -= 0*incBk;
   rB0 = alpha;
   rC0_0 *= rB0;
   *pC0 = rC0_0;
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_sJIK64x1x64NT3x1x4_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=64, NB=1, KB=64, 
 * lda=0, ldb=0, ldc=0, mu=3, nu=1, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 63;
   const float *stN = B + 1;
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 3 - (((lda) << 6)), incAn = -63;
   const int incBk = (ldb), incBm = -(((ldb) << 6));
   #define incBn 1
   #define incCm 3
   const int incCn = (ldc) - 63;
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2;
   register float rB0;
   register float rC0_0, rC1_0, rC2_0;
   do /* M-loop */
   {
      rA0 = BetaAlpha;
      rC0_0 = *pC0;
      rC0_0 *= rA0;
      rC1_0 = pC0[1];
      rC1_0 *= rA0;
      rC2_0 = pC0[2];
      rC2_0 *= rA0;
      for (k=64; k; k -= 4) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += rA0 * rB0;
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += rA0 * rB0;
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += rA0 * rB0;
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rA1 = pA0[1];
         rA2 = pA0[2];
         rC0_0 += rA0 * rB0;
         rC1_0 += rA1 * rB0;
         rC2_0 += rA2 * rB0;
         pA0 += incAk;
         pB0 += incBk;
      }
      pA0 -= 0*incAk;
      pB0 -= 0*incBk;
      rB0 = alpha;
      rC0_0 *= rB0;
      rC1_0 *= rB0;
      rC2_0 *= rB0;
      *pC0 = rC0_0;
      pC0[1] = rC1_0;
      pC0[2] = rC2_0;
      pC0 += incCm;
      pA0 += incAm;
      pB0 += incBm;
   }
   while(pA0 != stM);
   ATL_sJIK1x1x64NT1x1x4_aX_bX(1, 1, 64, alpha, ca + 63, lda, cb, ldb, beta, cc + 63, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_sJIK1x63x64NT1x7x4_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=1, NB=63, KB=64, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=7, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const float *stM = A + 1;
   const float *stN = B + 63;
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 1 - (((lda) << 6)), incAn = -1;
   const int incBk = (ldb), incBm = -(((ldb) << 6));
   #define incBn 7
   #define incCm 1
   const int incCn = (7*(ldc)) - 1;
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3, rB4, rB5, rB6;
   register float rC0_0, rC0_1, rC0_2, rC0_3, rC0_4, rC0_5, rC0_6;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+48);
      pfA += lda;
      rA0 = BetaAlpha;
      rC0_0 = *pC0;
      rC0_0 *= rA0;
      rC0_1 = *pC1;
      rC0_1 *= rA0;
      rC0_2 = *pC2;
      rC0_2 *= rA0;
      rC0_3 = *pC3;
      rC0_3 *= rA0;
      rC0_4 = *pC4;
      rC0_4 *= rA0;
      rC0_5 = *pC5;
      rC0_5 *= rA0;
      rC0_6 = *pC6;
      rC0_6 *= rA0;
      for (k=64; k; k -= 4) /* easy loop to unroll */
      {
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[1];
         rB2 = pB0[2];
         rB3 = pB0[3];
         rB4 = pB0[4];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[5];
         rC0_1 += rA0 * rB1;
         rB6 = pB0[6];
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[1];
         rB2 = pB0[2];
         rB3 = pB0[3];
         rB4 = pB0[4];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[5];
         rC0_1 += rA0 * rB1;
         rB6 = pB0[6];
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[1];
         rB2 = pB0[2];
         rB3 = pB0[3];
         rB4 = pB0[4];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[5];
         rC0_1 += rA0 * rB1;
         rB6 = pB0[6];
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         pA0 += incAk;
         pB0 += incBk;
         rA0 = *pA0;
         rB0 = *pB0;
         rB1 = pB0[1];
         rB2 = pB0[2];
         rB3 = pB0[3];
         rB4 = pB0[4];
         rC0_0 += rA0 * rB0;
         rB5 = pB0[5];
         rC0_1 += rA0 * rB1;
         rB6 = pB0[6];
         rC0_2 += rA0 * rB2;
         rC0_3 += rA0 * rB3;
         rC0_4 += rA0 * rB4;
         rC0_5 += rA0 * rB5;
         rC0_6 += rA0 * rB6;
         pA0 += incAk;
         pB0 += incBk;
      }
      pA0 -= 0*incAk;
      pB0 -= 0*incBk;
      rB0 = alpha;
      rC0_0 *= rB0;
      rC0_1 *= rB0;
      rC0_2 *= rB0;
      rC0_3 *= rB0;
      rC0_4 *= rB0;
      rC0_5 *= rB0;
      rC0_6 *= rB0;
      *pC0 = rC0_0;
      *pC1 = rC0_1;
      *pC2 = rC0_2;
      *pC3 = rC0_3;
      *pC4 = rC0_4;
      *pC5 = rC0_5;
      *pC6 = rC0_6;
      pC0 += incCm;
      pC1 += incCm;
      pC2 += incCm;
      pC3 += incCm;
      pC4 += incCm;
      pC5 += incCm;
      pC6 += incCm;
      pA0 += incAm;
      pB0 += incBm;
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_sJIK64x64x64NT0x0x0_aX_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=T, MB=64, NB=64, KB=64, 
 * lda=0, ldb=0, ldc=0, mu=3, nu=7, ku=4, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + 63;
   const float *stN = B + 63;
   const float *pfA = A + lda*M;
   const float BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 3 - (((lda) << 6)), incAn = -63;
   const int incBk = (ldb), incBm = -(((ldb) << 6));
   #define incBn 7
   #define incCm 3
   const int incCn = (7*(ldc)) - 63;
   float *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc), *pC5=pC4+(ldc), *pC6=pC5+(ldc);
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2;
   register float rB0, rB1, rB2, rB3, rB4, rB5, rB6;
   register float rC0_0, rC1_0, rC2_0, rC0_1, rC1_1, rC2_1, rC0_2, rC1_2, rC2_2, rC0_3, rC1_3, rC2_3, rC0_4, rC1_4, rC2_4, rC0_5, rC1_5, rC2_5, rC0_6, rC1_6, rC2_6;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      ATL_pfl1R(pfA+48);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         rC1_0 = pC0[1];
         rC1_0 *= rA0;
         rC2_0 = pC0[2];
         rC2_0 *= rA0;
         rC0_1 = *pC1;
         rC0_1 *= rA0;
         rC1_1 = pC1[1];
         rC1_1 *= rA0;
         rC2_1 = pC1[2];
         rC2_1 *= rA0;
         rC0_2 = *pC2;
         rC0_2 *= rA0;
         rC1_2 = pC2[1];
         rC1_2 *= rA0;
         rC2_2 = pC2[2];
         rC2_2 *= rA0;
         rC0_3 = *pC3;
         rC0_3 *= rA0;
         rC1_3 = pC3[1];
         rC1_3 *= rA0;
         rC2_3 = pC3[2];
         rC2_3 *= rA0;
         rC0_4 = *pC4;
         rC0_4 *= rA0;
         rC1_4 = pC4[1];
         rC1_4 *= rA0;
         rC2_4 = pC4[2];
         rC2_4 *= rA0;
         rC0_5 = *pC5;
         rC0_5 *= rA0;
         rC1_5 = pC5[1];
         rC1_5 *= rA0;
         rC2_5 = pC5[2];
         rC2_5 *= rA0;
         rC0_6 = *pC6;
         rC0_6 *= rA0;
         rC1_6 = pC6[1];
         rC1_6 *= rA0;
         rC2_6 = pC6[2];
         rC2_6 *= rA0;
         for (k=64; k; k -= 4) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[1];
            rA2 = pA0[2];
            rB1 = pB0[1];
            rB2 = pB0[2];
            rC0_0 += rA0 * rB0;
            rB3 = pB0[3];
            rC1_0 += rA1 * rB0;
            rB4 = pB0[4];
            rC2_0 += rA2 * rB0;
            rB5 = pB0[5];
            rC0_1 += rA0 * rB1;
            rB6 = pB0[6];
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC2_2 += rA2 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC2_3 += rA2 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            rC2_4 += rA2 * rB4;
            rC0_5 += rA0 * rB5;
            rC1_5 += rA1 * rB5;
            rC2_5 += rA2 * rB5;
            rC0_6 += rA0 * rB6;
            rC1_6 += rA1 * rB6;
            rC2_6 += rA2 * rB6;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[1];
            rA2 = pA0[2];
            rB1 = pB0[1];
            rB2 = pB0[2];
            rC0_0 += rA0 * rB0;
            rB3 = pB0[3];
            rC1_0 += rA1 * rB0;
            rB4 = pB0[4];
            rC2_0 += rA2 * rB0;
            rB5 = pB0[5];
            rC0_1 += rA0 * rB1;
            rB6 = pB0[6];
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC2_2 += rA2 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC2_3 += rA2 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            rC2_4 += rA2 * rB4;
            rC0_5 += rA0 * rB5;
            rC1_5 += rA1 * rB5;
            rC2_5 += rA2 * rB5;
            rC0_6 += rA0 * rB6;
            rC1_6 += rA1 * rB6;
            rC2_6 += rA2 * rB6;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[1];
            rA2 = pA0[2];
            rB1 = pB0[1];
            rB2 = pB0[2];
            rC0_0 += rA0 * rB0;
            rB3 = pB0[3];
            rC1_0 += rA1 * rB0;
            rB4 = pB0[4];
            rC2_0 += rA2 * rB0;
            rB5 = pB0[5];
            rC0_1 += rA0 * rB1;
            rB6 = pB0[6];
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC2_2 += rA2 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC2_3 += rA2 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            rC2_4 += rA2 * rB4;
            rC0_5 += rA0 * rB5;
            rC1_5 += rA1 * rB5;
            rC2_5 += rA2 * rB5;
            rC0_6 += rA0 * rB6;
            rC1_6 += rA1 * rB6;
            rC2_6 += rA2 * rB6;
            pA0 += incAk;
            pB0 += incBk;
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[1];
            rA2 = pA0[2];
            rB1 = pB0[1];
            rB2 = pB0[2];
            rC0_0 += rA0 * rB0;
            rB3 = pB0[3];
            rC1_0 += rA1 * rB0;
            rB4 = pB0[4];
            rC2_0 += rA2 * rB0;
            rB5 = pB0[5];
            rC0_1 += rA0 * rB1;
            rB6 = pB0[6];
            rC1_1 += rA1 * rB1;
            rC2_1 += rA2 * rB1;
            rC0_2 += rA0 * rB2;
            rC1_2 += rA1 * rB2;
            rC2_2 += rA2 * rB2;
            rC0_3 += rA0 * rB3;
            rC1_3 += rA1 * rB3;
            rC2_3 += rA2 * rB3;
            rC0_4 += rA0 * rB4;
            rC1_4 += rA1 * rB4;
            rC2_4 += rA2 * rB4;
            rC0_5 += rA0 * rB5;
            rC1_5 += rA1 * rB5;
            rC2_5 += rA2 * rB5;
            rC0_6 += rA0 * rB6;
            rC1_6 += rA1 * rB6;
            rC2_6 += rA2 * rB6;
            pA0 += incAk;
            pB0 += incBk;
         }
         pA0 -= 0*incAk;
         pB0 -= 0*incBk;
         rB0 = alpha;
         rC0_0 *= rB0;
         rC0_1 *= rB0;
         rC0_2 *= rB0;
         rC0_3 *= rB0;
         rC0_4 *= rB0;
         rC0_5 *= rB0;
         rC0_6 *= rB0;
         rC1_0 *= rB0;
         rC1_1 *= rB0;
         rC1_2 *= rB0;
         rC1_3 *= rB0;
         rC1_4 *= rB0;
         rC1_5 *= rB0;
         rC1_6 *= rB0;
         rC2_0 *= rB0;
         rC2_1 *= rB0;
         rC2_2 *= rB0;
         rC2_3 *= rB0;
         rC2_4 *= rB0;
         rC2_5 *= rB0;
         rC2_6 *= rB0;
         *pC0 = rC0_0;
         pC0[1] = rC1_0;
         pC0[2] = rC2_0;
         *pC1 = rC0_1;
         pC1[1] = rC1_1;
         pC1[2] = rC2_1;
         *pC2 = rC0_2;
         pC2[1] = rC1_2;
         pC2[2] = rC2_2;
         *pC3 = rC0_3;
         pC3[1] = rC1_3;
         pC3[2] = rC2_3;
         *pC4 = rC0_4;
         pC4[1] = rC1_4;
         pC4[2] = rC2_4;
         *pC5 = rC0_5;
         pC5[1] = rC1_5;
         pC5[2] = rC2_5;
         *pC6 = rC0_6;
         pC6[1] = rC1_6;
         pC6[2] = rC2_6;
         pC0 += incCm;
         pC1 += incCm;
         pC2 += incCm;
         pC3 += incCm;
         pC4 += incCm;
         pC5 += incCm;
         pC6 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pC1 += incCn;
      pC2 += incCn;
      pC3 += incCn;
      pC4 += incCn;
      pC5 += incCn;
      pC6 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
   ATL_sJIK64x1x64NT3x1x4_aX_bX(64, 1, 64, alpha, ca, lda, cb + 63, ldb, beta, cc + (63*(ldc)), ldc);
   ATL_sJIK1x63x64NT1x7x4_aX_bX(1, 63, 64, alpha, ca + 63, lda, cb, ldb, beta, cc + 63, ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
